/// This is part of the MTP Implementation
/// (C) Daniel Kirstenpfad 2004-2005
/// 
/// 08.01.2005	-	initial Release																					-	Daniel Kirstenpfad
/// 09.01.2005	-	FunctionalMode specific Handling implemented							-	Daniel Kirstenpfad
using System;

namespace MTP
{
	/// <summary>
	/// Implements the Command-Handlings
	/// </summary>
	public class CommandHandling
	{
		/// <summary>
		/// Checks if the given command is available in the device current FunctionalMode
		/// </summary>
		/// <param name="Command">OperationCode</param>
		/// <returns>true if command is available in current FunctionalMode, false if not</returns>
		public bool bCommandValidInCurrentFunctionalMode(OperationCodes command)
		{
			DeviceStatus dStatus = new DeviceStatus();
	
			foreach (OperationCodes Code in dStatus.currentDeviceOperationCodes())
			{
				if (Code == command)
				{
					return true;
				}
			}
			return false;
		}

		/// <summary>
		/// Checks if the given event is available in the device current FunctionalMode
		/// </summary>
		/// <param name="Event">EventCode</param>
		/// <returns>true if event is available in current FunctionalMode</returns>
		public bool bEventValidInCurrentFunctionalMode(EventCodes Event)
		{
			DeviceStatus dStatus = new DeviceStatus();
	
			foreach (EventCodes Code in dStatus.currentDeviceEventCodes())
			{
				if (Code == Event)
				{
					return true;
				}
			}

			return false;
		}

		public ResponseCodes OpenSession()
		{
			// TODO: Implement OpenSession Command
			return ResponseCodes.OperationNotSupported;
		}
		public void CloseSession()
		{
			// TODO: Implement CloseSession Command
		}
		public void CopyObject()
		{
			// TODO: Implement CopyObject Command
		}
		public void DeleteObject()
		{
			// TODO: Implement DeleteObject Command
		}
		public void FormatStore()
		{
			// TODO: Implement FormatStore Command
		}
		public void GetDeviceInfo()
		{
			// TODO: Implement GetDeviceInfo Command
		}
		public void GetDevicePropDesc()
		{
			// TODO: Implement GetDevicePropDesc Command
		}
		public void GetDevicePropValue()
		{
			// TODO: Implement GetDevicePropValue Command
		}
		public void GetNumObjects()
		{
			// TODO: Implement GetNumObjects Command
		}
		public void GetObject()
		{
			// TODO: Implement GetObject Command
		}
		public void GetObjectHandles()
		{
			// TODO: Implement GetObjectHandles Command
		}
		public void GetObjectInfo()
		{
			// TODO: Implement GetObjectInfo Command
		}
		public void GetPartialObject()
		{
			// TODO: Implement GetPartialObject Command
		}
		public void GetStorageIDs()
		{
			// TODO: Implement GetStorageIDs Command
		}
		public void GetStorageInfo()
		{
			// TODO: Implement GetStorageInfo Command
		}
		public void GetThumb()
		{
			// TODO: Implement GetThumb Command
		}
		public void InitiateCapture()
		{
			// TODO: Implement InitiateCapture Command
		}
		public void InitiateOpenCapture()
		{
			// TODO: Implement InitiateOpenCapture Command
		}
		public void MoveObject()
		{
			// TODO: Implement MoveObject Command
		}
		public void PowerDown()
		{
			// TODO: Implement ResetDevice Command
		}
		public void ResetDevicePropValue()
		{
			// TODO: Implement ResetDevicePropValue Command
		}
		public void SelfTest()
		{
			// TODO: Implement SelfTest Command
		}
		public void SendObjectInfo()
		{
			// TODO: Implement SendObjectInfo Command
		}
		public void SetDevicePropValue()
		{
			// TODO: Implement SetObjectProtection Command
		}
		public void SetObjectProtection()
		{
			// TODO: Implement SetObjectProtection Command
		}
		public void TerminateOpenCapture()
		{
			// TODO: Implement TerminateOpenCapture Command
		}
	}
}
