/// This is part of the MTP Implementation
/// (C) Daniel Kirstenpfad 2004-2005
/// 
/// 02.01.2005	-	initial Release																					-	Daniel Kirstenpfad
using System;

namespace MTP
{
	/// <summary>
	/// Implements Device-Informations for Windows Mobile 2003 Pocket PC (MDA2)
	/// </summary>
	public class DeviceSpecificInformations
	{
		public DeviceInfo DeviceInformations;
	
		#region Mapping of FunctionalMode and supported Events
		#region Standardmode
		public static EventCodes[] StandardmodeEvents = 	new EventCodes[14]
																									{	
																										EventCodes.CancelTransaction,
																										EventCodes.CaptureComplete,
																										EventCodes.DeviceInfoChanged,
																										EventCodes.DevicePropChanged,
																										EventCodes.DeviceReset,
																										EventCodes.ObjectAdded,
																										EventCodes.ObjectInfoChanged,
																										EventCodes.ObjectRemoved,
																										EventCodes.RequestObjectTransfer,
																										EventCodes.StorageInfoChanged,
																										EventCodes.StoreAdded,
																										EventCodes.StoreFull,
																										EventCodes.StoreRemoved,
																										EventCodes.UnreportedStatus
																									};
		#endregion
		#region Sleepstate
		// TODO: Implement SleepstateEvent Mapping
        public static EventCodes[] SleepstateEvents = new EventCodes[1]
																									{
																										EventCodes.Undefined
																									};
		#endregion
		#region ResponsivePlayback
        // TODO: Implement ResponsivePlaybackEvent Mapping
		public static EventCodes[] ResponsivePlaybackEvents = new EventCodes[1]
																									{
																										EventCodes.Undefined
																									};
		#endregion
		#region NonResponsivePlayback
		// TODO: Implement NonResponsivePlaybackEvent Mapping
        public static EventCodes[] NonResponsivePlaybackEvents = new EventCodes[1]
																									{
																										EventCodes.Undefined
																									};
		#endregion
		#endregion
	
		#region Mapping of FunctionalMode and supported Operations
		#region Standardmode
		public static OperationCodes[]  StandardmodeOperations = new OperationCodes[27] 
																									{
																										OperationCodes.CloseSession,
																										OperationCodes.CopyObject,
																										OperationCodes.DeleteObject,
																										OperationCodes.FormatStore,
																										OperationCodes.GetDeviceInfo,
																										OperationCodes.GetDevicePropDesc,
																										OperationCodes.GetDevicePropValue,
																										OperationCodes.GetNumObjects,
																										OperationCodes.GetObject,
																										OperationCodes.GetObjectHandles,
																										OperationCodes.GetObjectInfo,
																										OperationCodes.GetPartialObject,
																										OperationCodes.GetStorageIDs,
																										OperationCodes.GetStorageInfo,
																										OperationCodes.GetThumb,
																										OperationCodes.InitiateCapture,
																										OperationCodes.InitiateOpenCapture,
																										OperationCodes.MoveObject,
																										OperationCodes.OpenSession,
																										OperationCodes.PowerDown,
																										OperationCodes.ResetDevice,
																										OperationCodes.ResetDevicePropValue,
																										OperationCodes.SelfTest,
																										OperationCodes.SendObjectInfo,
																										OperationCodes.SetDevicePropValue,
																										OperationCodes.SetObjectProtection,
																										OperationCodes.TerminateOpenCapture
																									};
		#endregion
		#region SleepState
		// TODO: SleepStateOperation Mapping
		public static OperationCodes[]  SleepStateOperations = new OperationCodes[1] 
																									{	
																										OperationCodes.Undefined 
																									};
		#endregion
		#region ResponsivePlayback
		// TODO: ResponsivePlaybackOperation Mapping
		public static OperationCodes[]  ResponsivePlaybackOperations = new OperationCodes[1] 
																									{	
																										OperationCodes.Undefined 
																									};
		#endregion	
		#region NonResponsivePlayback
		// TODO: NonResponsivePlaybackOperation Mapping
		public static OperationCodes[]  NonResponsivePlaybackOperations = new OperationCodes[1] 
																									{	
																										OperationCodes.Undefined 
																									};
		#endregion
		#endregion
		
		public DeviceSpecificInformations()
		{
			DeviceInformations = new DeviceInfo();
			
			DeviceInformations.StandardVersion = 100;
			DeviceInformations.DeviceVersion = "1.0";
			DeviceInformations.Model = "T-Mobile MDA2 (Windows Mobile 2003)";
			DeviceInformations.Manufacturer = "BtK/Qtek/T-Mobile";
			DeviceInformations.SerialNumber = "BTKPPCMTP0001";
			DeviceInformations.VendorExtensionID = VendorIDs.Microsoft;
			DeviceInformations.VendorExtensionVersion = 100;
			DeviceInformations.VendorExtensionDesc = "microsoft.com: 1.0;";

			DeviceInformations.FunctionalMode = FunctionalModes.StandardMode;

			// Formats that can be displayed by this device
			DeviceInformations.PlaybackFormats = new ObjectFormats[11] 
																												{
																													ObjectFormats.AVI,
																													ObjectFormats.ASF, 
																													ObjectFormats.MPEG, 
																													ObjectFormats.BMP,
																													ObjectFormats.EXIF_JPEG, 
																													ObjectFormats.GIF, 
																													ObjectFormats.AIFF, 
																													ObjectFormats.MP3,
																													ObjectFormats.WAV,
																													ObjectFormats.Text,
																													ObjectFormats.HTML
																												};

			// Formats that are generated by this device
			DeviceInformations.CaptureFormats = new ObjectFormats[7]{
																													ObjectFormats.BMP,
																													ObjectFormats.EXIF_JPEG,
																													ObjectFormats.GIF,
																													ObjectFormats.PNG,
																													ObjectFormats.TIFF,
																													ObjectFormats.Text,
																													ObjectFormats.HTML
																													};
			
			// Events that are initially supported by this device
			DeviceInformations.EventsSupported = StandardmodeEvents;

			// Operations that are initially supported by this device
			DeviceInformations.OperationsSupported = StandardmodeOperations;
		}
	}
}
